#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <MEPT-utils.h>
#include <aterm2.h>
#include "asf-builtins.h"

/* DO NOT EDIT: This file is generated */

static ATbool initialized = ATfalse;

void initBuiltins(void)
{
  initialized = ATtrue;

  return;
}

/* Naive implementation: just do strcmp's until we find the correct
 * function. Idea: use asc-support or similar hashtable implementation.
 */
PT_Tree forwardBuiltin(ATerm builtin, PT_Tree input)
{
  AFun afun;
  char *name = NULL;
  PT_Tree result = input;

  assert(initialized && "builtins are not initialized");
  assert(ATgetType(builtin) == AT_APPL && "builtins should be ATermAppls");

  afun = ATgetAFun(builtin);
  name = ATgetName(afun);

  if (!strcmp(name, "set-anno")) {
    result = set_anno(builtin, input);
  }
  if (!strcmp(name, "get-anno")) {
    result = get_anno(builtin, input);
  }
  if (!strcmp(name, "asf-normalize")) {
    result = asf_normalize(builtin, input);
  }
  if (!strcmp(name, "read-term-from-file")) {
    result = read_term_from_file(builtin, input);
  }
  if (!strcmp(name, "write-term-to-file")) {
    result = write_term_to_file(builtin, input);
  }
  if (!strcmp(name, "shell")) {
    result = shell(builtin, input);
  }
  if (!strcmp(name, "hashtable-lookup")) {
    result = hashtable_lookup(builtin, input);
  }
  if (!strcmp(name, "hashtable-store")) {
    result = hashtable_store(builtin, input);
  }
  if (!strcmp(name, "hashtable-delete")) {
    result = hashtable_delete(builtin, input);
  }
  if (!strcmp(name, "strategy-some")) {
    result = strategy_some(builtin, input);
  }
  if (!strcmp(name, "strategy-all")) {
    result = strategy_all(builtin, input);
  }
  if (!strcmp(name, "strategy-one")) {
    result = strategy_one(builtin, input);
  }

  return result; 
}
